require 'test/unit'
require 'tres_bot'

class BotTest < Test::Unit::TestCase

  def setup
    @robot = TresBot::Robot.new
  end

  def test_place
    @robot.place([1,1,"NORTH"])
    assert_equal(@robot.report, "1, 1, NORTH")
  end

  def test_left
    @robot.place([1,1,"NORTH"])
    @robot.left
    assert_equal(@robot.report, "1, 1, WEST")
  end

  def test_right
    @robot.place([1,1,"NORTH"])
    @robot.right
    assert_equal(@robot.report, "1, 1, EAST")
  end

  def test_move
    @robot.place([1,1,"NORTH"])
    @robot.move
    @robot.report
    assert_equal(@robot.report, "1, 2, NORTH")
  end

  def test_x_axis_end_boundary
    @robot.place([4,1,"EAST"])
    @robot.move
    @robot.report
    assert_equal(@robot.report, "4, 1, EAST")
  end

  def test_x_axis_start_boundary
    @robot.place([0,1,"WEST"])
    @robot.move
    @robot.report
    assert_equal(@robot.report, "0, 1, WEST")
  end

  def test_y_axis_end_boundary
    @robot.place([3,4,"NORTH"])
    @robot.move
    @robot.report
    assert_equal(@robot.report, "3, 4, NORTH")
  end

  def test_y_axis_start_boundary
    @robot.place([3,0,"SOUTH"])
    @robot.move
    @robot.report
    assert_equal(@robot.report, "3, 0, SOUTH")
  end

end